import '../renderer/stage.dart';
import '../extensions/extensions.dart';

abstract class BaseInfo<T> {
  final T raw;
  BaseInfo(this.raw);
}

abstract class PositionInfo<T> extends BaseInfo<T> {
  final EventPosition eventPosition;

  PositionInfo(Stage stage, Offset globalPosition, T raw)
      : eventPosition = EventPosition(stage, globalPosition),
        super(raw);
}

// TODO: 删除
class EventPosition {
  final Vector2 global;
  final Vector2 game;

  EventPosition(Stage _stage, Offset globalPosition)
      : global = globalPosition.toVector2(),
        game = _stage.convertGlobalToLocalCoordinate(globalPosition.toVector2());
}

class EventDelta {
  final Vector2 global;
  final Vector2 game;

  EventDelta(Stage _stage, Offset _delta)
      : global = _delta.toVector2(),
        game = _delta.toVector2();
}

mixin HandledField {
  bool handled = false;
}
