import 'package:flutter/gestures.dart';

import '../renderer/stage.dart';
import 'events.dart';

mixin ScrollDetectorMixin on Stage {
  void onScroll(PointerScrollInfo info) {}
}

class PointerScrollInfo extends PositionInfo<PointerScrollEvent> {
  final EventDelta scrollDelta;

  PointerScrollInfo.fromDetails(Stage stage, PointerScrollEvent raw)
      : scrollDelta = EventDelta(stage, raw.scrollDelta),
        super(stage, raw.position, raw);
}
